#---------------------------------------------------------------------
#
#  Constant values used for Pre Processor file handling
#
#  Pere Casellas
#  Stefan Feuz
#  http://www.laboratoridenvol.com
#
#  General Public License GNU GPL 3.0
#
#---------------------------------------------------------------------

#---------------------------------------------------------------------
# Constant values
#---------------------------------------------------------------------

global c_VersionSect_lFC_Id
set c_VersionSect_lFC_Id "section-id-000"

#---------
# Geometry
global c_GeometrySect_lFC_Lbl
set c_GeometrySect_lFC_Lbl "1. GEOMETRY"
global c_GeometrySect_lFC_Id
set c_GeometrySect_lFC_Id "section-id-010"

#--------
# Airfoil
global c_AirfoilSect_lFC_Lbl
set c_AirfoilSect_lFC_Lbl "2. AIRFOILS"
global c_AirfoilSect_lFC_Id
set c_AirfoilSect_lFC_Id "section-id-020"

#--------------
# Anchor points
global c_AnchorPoSect_lFC_Lbl
set c_AnchorPoSect_lFC_Lbl "3. ANCHOR"
global c_AnchorPoSect_lFC_Id
set c_AnchorPoSect_lFC_Id "section-id-030"

#--------------
# Airfoil holes
global c_AirfoilHoSect_lFC_Lbl
set c_AirfoilHoSect_lFC_Lbl "4. AIRFOIL HOLES"
global c_AirfoilHoSect_lFC_Id
set c_AirfoilHoSect_lFC_Id "section-id-040"

#-------------
# Skin tension
global c_SkinTensSect_lFC_Lbl
set c_SkinTensSect_lFC_Lbl "5. SKIN TENSION"
global c_SkinTensSect_lFC_Id
set c_SkinTensSect_lFC_Id "section-id-050"

#------------------
# Sewing allowances
global c_SewingSect_lFC_Lbl
set c_SewingSect_lFC_Lbl "6. SEWING ALLOWANCES"
global c_SewingSect_lFC_Id
set c_SewingSect_lFC_Id "section-id-060"

#------
# Marks
global c_MarksSect_lFC_Lbl
set c_MarksSect_lFC_Lbl "7. MARKS"
global c_MarksSect_lFC_Id
set c_MarksSect_lFC_Id "section-id-070"

#-----------------------
# Global angle of attack
global c_GlobalAoASect_lFC_Lbl
set c_GlobalAoASect_lFC_Lbl "8. Global angle of attack estimation"
global c_GlobalAoASect_lFC_Id
set c_GlobalAoASect_lFC_Id "section-id-080"

#-----------------
# Suspension lines
global c_SuspLinesSect_lFC_Lbl
set c_SuspLinesSect_lFC_Lbl "9. SUSPENSION LINES"
global c_SuspLinesSect_lFC_Id
set c_SuspLinesSect_lFC_Id "section-id-090"

#-------
# Brakes
global c_BrakesSect_lFC_Lbl
set c_BrakesSect_lFC_Lbl "10. BRAKES"
global c_BrakesSect_lFC_Id
set c_BrakesSect_lFC_Id "section-id-100"

#---------------------
# Ramification lengths
global c_RamLengthSect_lFC_Lbl
set c_RamLengthSect_lFC_Lbl "11. Ramification"
global c_RamLengthSect_lFC_Id
set c_RamLengthSect_lFC_Id "section-id-110"

#----------------
# H V and VH ribs => miniRib
global c_MiniRibSect_lFC_Lbl
set c_MiniRibSect_lFC_Lbl "12. H V"
global c_MiniRibSect_lFC_Id
set c_MiniRibSect_lFC_Id "section-id-120"

#----------------------
# Trailing edge  colors
global c_TeColSect_lFC_Lbl
set c_TeColSect_lFC_Lbl "15. Extrados colors"
global c_TeColSect_lFC_Id
set c_TeColSect_lFC_Id "section-id-150"

#--------------------
# Leading edge colors
global c_LeColSect_lFC_Lbl
set c_LeColSect_lFC_Lbl "16. Intrados colors"
global c_LeColSect_lFC_Id
set c_LeColSect_lFC_Id "section-id-160"

#----------------------
# Additional rib points
global c_AddRibPoSect_lFC_Lbl
set c_AddRibPoSect_lFC_Lbl "17. Aditional rib points" 
global c_AddRibPoSect_lFC_Id
set c_AddRibPoSect_lFC_Id "section-id-170"

#--------------------------
# Elastig lines corrections
global c_ElLinesCorrSect_lFC_Lbl
set c_ElLinesCorrSect_lFC_Lbl "18. Elastic lines corrections"
global c_ElLinesCorrSect_lFC_Id
set c_ElLinesCorrSect_lFC_Id "section-id-180"

#----------------------
# DXF layer names
global c_DXFLayNaSect_lFC_Lbl
set c_DXFLayNaSect_lFC_Lbl "19. DXF layer names" 
global c_DXFLayNaSect_lFC_Id
set c_DXFLayNaSect_lFC_Id "section-id-190"

#----------------------
# Marks types
global c_MarksTySect_lFC_Lbl
set c_MarksTySect_lFC_Lbl "20. Marks types" 
global c_MarksTySect_lFC_Id
set c_MarksTySect_lFC_Id "section-id-200"

#----------------------
# Joncs definition
global c_JoncsDefSect_lFC_Lbl
set c_JoncsDefSect_lFC_Lbl "21. JONCS DEFINITION" 
global c_JoncsDefSect_lFC_Id
set c_JoncsDefSect_lFC_Id "section-id-210"

#----------------------
# Nose mylars definition
global c_NoseMySect_lFC_Lbl
set c_NoseMySect_lFC_Lbl "22. NOSE MYLARS DEFINITION" 
global c_NoseMySect_lFC_Id
set c_NoseMySect_lFC_Id "section-id-220"

#----------------------
# Tab reinforcements
global c_TabReinfSect_lFC_Lbl
set c_TabReinfSect_lFC_Lbl "23. TAB REINFORCEMENTS" 
global c_TabReinfSect_lFC_Id
set c_TabReinfSect_lFC_Id "section-id-230"

#----------------------
# General 2D DXF options
global c_Ge2DopSect_lFC_Lbl
set c_Ge2DopSect_lFC_Lbl "24. GENERAL 2D DXF OPTIONS" 
global c_Ge2DopSect_lFC_Id
set c_Ge2DopSect_lFC_Id "section-id-240"

#----------------------
# General 3D DXF options
global c_Ge3DopSect_lFC_Lbl
set c_Ge3DopSect_lFC_Lbl "25. GENERAL 3D DXF OPTIONS" 
global c_Ge3DopSect_lFC_Id
set c_Ge3DopSect_lFC_Id "section-id-250"

#----------------------
# Glue vents
global c_GlueVenSect_lFC_Lbl
set c_GlueVenSect_lFC_Lbl "26. GLUE VENTS" 
global c_GlueVenSect_lFC_Id
set c_GlueVenSect_lFC_Id "section-id-260"

#----------------------
# Special wing tip
global c_SpecWtSect_lFC_Lbl
set c_SpecWtSect_lFC_Lbl "27. SPECIAL WING TIP" 
global c_SpecWtSect_lFC_Id
set c_SpecWtSect_lFC_Id "section-id-270"

#----------------------
# Parameters for calage variation
global c_CalagVarSect_lFC_Lbl
set c_CalagVarSect_lFC_Lbl "28. PARAMETERS FOR CALAGE VARIATION" 
global c_CalagVarSect_lFC_Id
set c_CalagVarSect_lFC_Id "section-id-280"

#----------------------
# 3D SHAPING
global c_P3DShapingSect_lFC_Lbl
set c_P3DShapingSect_lFC_Lbl "29. 3D SHAPING" 
global c_P3DShapingSect_lFC_Id
set c_P3DShapingSect_lFC_Id "section-id-290"

#----------------------
# Airfoil thickness modification
global c_AirThickSect_lFC_Lbl
set c_AirThickSect_lFC_Lbl "30. AIRFOIL THICKNESS MODIFICATION"
global c_AirThickSect_lFC_Id
set c_AirThickSect_lFC_Id "section-id-300"

#----------------------
# New skin tension module
global c_NewSkinSect_lFC_Lbl
set c_NewSkinSect_lFC_Lbl "31. NEW SKIN TENSION MODULE"
global c_NewSkinSect_lFC_Id
set c_NewSkinSect_lFC_Id "section-id-310"

#--------------------------
# DXF
global c_DxfSect_lFC_Id
set c_DxfSect_lFC_Id "section-id-320"


#---------------------------------------------------------------------
# Global values
#---------------------------------------------------------------------

global g_LepFilePathName
